#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/errno.h>

#define SERV_PORT  5134

#define MAXNAME    1024

extern int errno;

main()
{
   int socket_fd;       /* file descriptor into transport */
   int recfd;           /* file descriptor to accept      */
   int length;          /* length of address structure    */
   struct sockaddr_in myaddr; /* address of this service  */
   struct sockaddr_in client_addr; /* address of client   */
   /*
    *  Get a socket into TCP/IP.
    */

   if ((socket_fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
      perror("socket failed");
      exit(1);
   }

   /*
    *  Set up our address.
    */

   bzero((char *)&myaddr, sizeof(myaddr));
   myaddr.sin_family = AF_INET;
   myaddr.sin_addr.s_addr = htonl(INADDR_ANY);
   myaddr.sin_port = htons(SERV_PORT);

   /*
    *  Bind to the address to which the service
    *  will be offered.
    */

   if (bind(socket_fd, (struct sockaddr *)&myaddr,
                            sizeof(myaddr)) < 0) {
      perror("bind failed");
      exit(1);
   }
   /*
    *  Set up the socket for listening, with a queue
    *  length of 5.
    */

   if (listen(socket_fd, 5) < 0) {
      perror("listen failed");
      exit(1);
   }

   /*
    *  Loop continuously, waiting for connection requests
    *  and performing the service.
    */

   length = sizeof(client_addr);
   while (1) {
      if ((recfd = accept(socket_fd,
        (struct sockaddr_in *)&client_addr, &length)) < 0) {
         perror("could not accept call");
         exit(1);
      }
      switch (fork()) {

         case -1:
            perror("fork failed!\n");
            exit(1);
        
         default: /* parent */
        
            close(recfd);
            /*
             * Break out of switch and continue loop.
             */
            break;

         case 0:  /* child */
        
            close(socket_fd);
            /*
             *  perform_actions() never returns.
             */
            perform_actions(recfd);
      }
   }
}
int
perform_actions(conn_fd)
int conn_fd;
{
   int done = 0;     /* indicates all data are read       */
   int where = 0;    /* points to where we are in buffer  */
   int nbytes;       /* the number of bytes read          */
   char reply;       /* 'y' or an 'n' to reply to client  */
   char buf[BUFSIZ]; /* buffer to hold the name           */

   char cmd[BUFSIZ];          /* used to figure out if    */
   char junkbuf[BUFSIZ];      /* the user is logged onto  */
   FILE *fp;                  /* the system               */

   for (;;) {
      /*
       *  Read the user name from the client.
       */
      where = 0;
      do {
         if ((BUFSIZ - where) == 0) {
            exit(1);
         }
         if ((nbytes = read(conn_fd, &buf[where],
                                      BUFSIZ-where)) < 0) {
            if (errno != ECONNRESET) {
               perror("read of data failed!");
               exit(1);
            } else {
               exit(0);
            }
         }
         where += nbytes;
         if (buf[where - 1] == '\0') {
            done = 1;
         }
      } while (!done);
   
      /*
       *  Determine if the user is logged on...
       */
      sprintf(cmd, "who | grep '^%s '", buf);
      if ((fp = popen(cmd, "r")) == NULL
       || fgets(junkbuf, BUFSIZ, fp) == NULL) {
         reply = 'n';
      } else {
         reply = 'y';
      }
   
      /*
       *  Send a "y" or an "n" to the client.
       */
      if (write(conn_fd, &reply, 1) < 0) {
         perror("write failed!");
         exit(1);
      }
   }
}
